
package de.ivu.elect.presentation.ergebnis.table;

import java.util.ArrayList;
import java.util.List;

import javax.enterprise.inject.Specializes;

import de.ivu.elect.business.ergebnis.entity.Ergebnis;
import de.ivu.elect.jee.presentation.dynamictable.ColumnEntry;

@Specializes
public class WasErgebnisColumnBuilder extends ErgebnisColumnBuilder {

  private static final long serialVersionUID = 1L;

  private AbstractErgebnisColumn<Ergebnis> ergebnisErgebnisartColumn;

  private AbstractErgebnisColumn<Ergebnis> ergebnisErgebnisStatusColumn;

  private AbstractErgebnisColumn<Ergebnis> ergebnisEingangssequenznummerColumn;

  private AbstractErgebnisColumn<Ergebnis> ergebnisSitzberechnungsalgorithmusNameColumn;

  private AbstractErgebnisColumn<Ergebnis> ergebnisZeitstempelColumn;

  private AbstractErgebnisColumn<Ergebnis> ergebnisAusloeserColumn;

  @Override
  protected void initColumns() {
    super.initColumns();

    ergebnisErgebnisartColumn = AbstractErgebnisColumn.createErgebnisErgebnisartColumn(getMessages());
    ergebnisErgebnisStatusColumn = AbstractErgebnisColumn.createErgebnisErgebnisStatusColumn(getMessages());
    ergebnisEingangssequenznummerColumn = AbstractErgebnisColumn.createErgebnisEingangssequenznummerColumn(getMessages());
    ergebnisSitzberechnungsalgorithmusNameColumn = AbstractErgebnisColumn.createErgebnisSitzberechnungsalgorithmusColumn(getMessages());
    ergebnisZeitstempelColumn = AbstractErgebnisColumn.createErgebnisZeitstempelColumn(getMessages());
    ergebnisAusloeserColumn = AbstractErgebnisColumn.createErgebnisAusloeserColumn(getMessages());
  }

  @Override
  protected List<ColumnEntry< ? super Ergebnis>> getColumnEntriesSorted() {
    List<ColumnEntry< ? super Ergebnis>> result = new ArrayList<>();

    result.add(ergebnisErgebnisartColumn);
    result.add(ergebnisNameColumn);
    result.add(ergebnisErgebnisStatusColumn);
    result.add(ergebnisEingangssequenznummerColumn);
    result.add(ergebnisZeitstempelColumn);
    result.add(ergebnisAusloeserColumn);
    result.add(ergebnisSitzberechnungsalgorithmusNameColumn);
    result.add(ergebnisBemerkungColumn);

    return result;
  }
}
